<?php

namespace App\Http\Controllers;
use Illuminate\Support\Facades\DB;
use Illuminate\Http\Request;
use Carbon;
use Illuminate\Support\Facades\Storage;
//https://www.kfacrm.com/blog/public/api/add_verbal
class verbal_controller extends Controller
{
    
       public function update_profiles_Used(Request $request, $id_user)
                {
                    // Fetch the old image details
                    $oldImage = DB::table('profile_users')
                        ->where('profile_users.id_user', $id_user)
                        ->first();
                
                    // Delete the old image record from the database
                    DB::table('profile_users')
                    ->where('profile_users.id_user', $id_user)
                    ->delete();
                
                    // Check if the old image exists in storage and delete it
                    if ($oldImage && $oldImage->url) {
                        // Extract the relative path from the URL
                        $relativePath = str_replace(
                            'https://www.oneclickonedollar.com/laravel_kfa_2023/public/data_imgs_kfa/	
images_user/',
                            '',
                            $oldImage->url
                        );
                
                        // Delete the file from the `images_user` directory delete
                        Storage::disk('kfa')->delete($relativePath);
                    }
                
                    // Check if a new image is provided
                    if ($request->hasFile('image')) {
                        $name = $request->file('image')->getClientOriginalName();
                        $url = $request->file('image')->storeAs('images_user', $name, 'kfa');
                
                        // Insert the new image details into the database
                        DB::table('profile_users')->insert([
                            'id_user' => $id_user,
                            'image' => $name,
                            'url' => 'https://www.kfacrm.com/blog/public/public/data_imgs_kfa/' . $url,
                        ]);
                    
                        return response()->json([
                            "message" => "Save Successfully",
                        ]);
                    } else {
                        return response()->json([
                            "message" => "Don't Save Successfully",
                            "url"
                        ]);
                    }
                }
    
    public function deletelandbuilding(Request $request){
       
         $listData = $request->input();
        foreach($listData["landbuilding"] as $value) {
        DB::table('verbal_land_models')
            ->where('verbal_land_id', $value)
            ->delete();  
        }
        return 'Deleted successfuly';
    }
    public function updateAuto(Request $request){
           $verballand_DB = DB::table('verbal_land_models')
           ->where('verbal_land_id',$request->verbal_land_id )
           ->update([
                'verbal_land_type'=> $request->verbal_land_type,
                'verbal_land_des'=> $request->verbal_land_des,
                'verbal_land_area' => $request->verbal_land_area,
                'verbal_land_minsqm'=> $request->verbal_land_minsqm,
                'verbal_land_maxsqm'=> $request->verbal_land_maxsqm,
                'verbal_land_minvalue'=> $request->verbal_land_minvalue,
                'verbal_land_maxvalue'=> $request->verbal_land_maxvalue,
                'address'=> $request->address
                // 'type_value'=>  "T" 
               ]);
            return "Update successful";   
        }
        public function fetchData(){
            $verbal_DB = DB::table('verbal_backup_models')
            ->get();
            return $verbal_DB;
        }
    public function editAuto(Request $request){
           $verbal_DB = DB::table('verbal_backup_models')
           ->where('verbal_id',$request->verbal_id)
           ->update([
                'title_number'=> $request->title_number,
                'borey'=> $request->borey,
                'road'=> $request->road,
                'verbal_property_id' => $request->verbal_property_id,
                'verbal_bank_id'=> $request->verbal_bank_id,
                'verbal_bank_branch_id'=> $request->verbal_bank_branch_id,
                'verbal_bank_contact'=> $request->verbal_bank_contact,
                'verbal_owner'=> $request->verbal_owner,
                'verbal_contact'=> $request->verbal_contact,
                'verbal_date'=>  Carbon\Carbon::parse($request->verbal_date),
                'verbal_bank_officer'=> $request->verbal_bank_officer,
                'verbal_address'=> $request->verbal_address,
                'verbal_approve_id'=> $request->verbal_approve_id,
                'latlong_log'=>  $request->latlong_log,
                'latlong_la'=>  $request->latlong_la, 
                'verbalImage' =>  $request->verbalImage??"No",
                'verbal_user'=>  $request->verbal_user,
                // 'protectID'=>  $request->protectID,
                'verbal_option'=> $request->verbal_option,   
               ]);
            $comverbalData = $request->input(); 
            foreach ($comverbalData["VerbalType"] as $key => $value) {
                    DB::table('verbal_land_backup_models')->insert([
                        'verbal_land_type' => $value['verbal_land_type'],
                        'verbal_landid' => $value['verbal_landid'],
                        'verbal_land_des' => $value['verbal_land_des'],
                        'verbal_land_area' => $value['verbal_land_area'],
                        'verbal_land_minsqm' => $value['verbal_land_minsqm'],
                        'verbal_land_maxsqm' => $value['verbal_land_maxsqm'],
                        'verbal_land_minvalue' => $value['verbal_land_minvalue'],
                        'verbal_land_maxvalue' => $value['verbal_land_maxvalue'],
                        'address' => $value['address'],
                        'type_value' => "T"
                    ]);
            }
            
            return "Update Successfuly";
        }
      public function delete_Autoverbal(Request $request) {
          $verbal_DB = DB::table('verbal_backup_models');
          $verballand_DB = DB::table('verbal_land_backup_models');
        if($request->has('protectID')){
          $verbal_DB
         ->where('protectID', $request->protectID)
         ->delete();
         $verballand_DB
        ->where('verbal_landid', $request->protectID)
        ->delete(); 
        }else if($request->has('verbal_id')){
         $verbal_DB 
         ->where('verbal_id', $request->verbal_id)
         ->delete();
         $verballand_DB
        ->where('verbal_landid', $request->verbal_id)
        ->delete();
        }else{
            
            return response()->json(['error' => 'Invalid request, missing parameters.'], 400);
        }
       
        return response()->json(['success' => 'deleted successfully.'], 200);
    }
    
      public function autoverbal_save(Request $request){
            $verbal_id=$request->verbal_id;
            $validated = $request->validate([
                'latlong_log'=>'required|numeric',
                'latlong_la'=>'required|numeric'
            ]);
            $input = DB::table('verbal_backup_models')
                ->insert([
                'title_number'=> $request->title_number,
                'phume'=> $request->phume,
                'onesignal_ID'=> $request->onesignal_ID,
                'borey'=> $request->borey,
                'road'=> $request->road,
                'verbal_property_id' => $request->verbal_property_id,
                'verbal_bank_id'=> $request->verbal_bank_id,
                'approvel'=> $request->approvel,
                'verbal_bank_branch_id'=> $request->verbal_bank_branch_id,
                'verbal_bank_contact'=> $request->verbal_bank_contact,
                'verbal_owner'=> $request->verbal_owner,
                'verbal_contact'=> $request->verbal_contact,
                'verbal_date'=>  Carbon\Carbon::parse($request->verbal_date),
                'verbal_bank_officer'=> $request->verbal_bank_officer,
                'verbal_address'=> $request->verbal_address,
                'verbal_approve_id'=> $request->verbal_approve_id,
                'latlong_log'=>  $validated['latlong_log'],
                'latlong_la'=>  $validated['latlong_la'], 
                'verbalImage' =>  $request->verbalImage??"No",
                'verbal_user'=>  $request->verbal_user,
                'protectID'=>  $request->protectID,
                'verbal_option'=> $request->verbal_option,
                'type_value'=> "T",
                    ]);
                 $comverbalData = $request->input(); 
                foreach ($comverbalData["VerbalType"] as $key => $value) {
                    DB::table('verbal_land_backup_models')->insert([
                        'verbal_land_type' => $value['verbal_land_type'],
                        'verbal_landid' => $request->protectID,
                        'verbal_land_des' => $value['verbal_land_des'],
                        'verbal_land_area' => $value['verbal_land_area'],
                        'verbal_land_minsqm' => $value['verbal_land_minsqm'],
                        'verbal_land_maxsqm' => $value['verbal_land_maxsqm'],
                        'verbal_land_minvalue' => $value['verbal_land_minvalue'],
                        'verbal_land_maxvalue' => $value['verbal_land_maxvalue'],
                        // 'verbal_land_dp' => $value['verbal_land_dp'],
                        'address' => $value['address'],
                        // 'type_value' => $value['type_value'],
                    ]);
                }
                return response()->json([
                //  $comverbalData
                "message"=> "Post Successfuly",
            ]);
        }
}
